!AscendSpeed = $FC
!LeftSpeed = $F8
!RightSpeed = $08

print "INIT ",pc
RTL

print "MAIN ",pc
PHB
PHK
PLB
JSR Starman
PLB
RTL

Starman:
LDA #!AscendSpeed
STA $AA,x
LDY #!LeftSpeed
LDA $14
BPL +
LDY #!RightSpeed
+
STY $B6,x
JSL $018022		;update xpos no gravity
JSL $01801A		;update ypos no gravity

JSL HandleOffscreen
JSR Graphics
JSL $01A7DC             ; check for mario/sprite contact (carry set = contact)
BCC Return
Contact:
LDA #$0A
STA $1DF9
STZ $14C8,x		;erase star
JSL $01C580		;Give mario star
LDA #$04
JSL $02ACE5
Return:
RTS

Graphics:
JSL GET_DRAW_INFO
LDA $00
STA $0300,y
LDA $01
STA $0301,y
LDA #$48
STA $0302,y

LDA $14
AND #$07
LSR A
PHX
TAX
LDA PalTBL,x
ORA $64
STA $0303,y
PLX
JSR FrozenParticle

LDY #$02
LDA #$00
JSL $01B7B3
RTS

PalTBL:	db $08,$04,$00,$04

HandleOffscreen:
			STZ $03
			PHB
			LDA #$01
			PHA
			PLB
			PEA $801F
			JML $81AC33


SPR_T1:			db $0C,$1C
SPR_T2:			db $01,$02

GET_DRAW_INFO:		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X:		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC #$0040
			CMP #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			PHB
			PHK
			PLB
			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP:		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y:		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			PLB
			RTL

INVALID:		REP #$20
			PLA
			PLY
			PLA
			PHY
			PHA
			SEP #$20
			RTL

FrozenParticle:
	LDA $13
	AND #$07	;Every 7 frames, generate ice particle
	ORA $9D

	PHK
	PEA.w .jslrtsreturn-1
	PEA $90B8
	JML $01B152
.jslrtsreturn
	RTS